diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/spectrum/helper/tv-spectrum-transmitter-helper.cc ns-3.38/src/spectrum/helper/tv-spectrum-transmitter-helper.cc
--- ns-3.37/src/spectrum/helper/tv-spectrum-transmitter-helper.cc	2022-11-01 17:37:24.711395700 -0700
+++ ns-3.38/src/spectrum/helper/tv-spectrum-transmitter-helper.cc	2023-03-16 20:54:23.824869200 -0700
@@ -46,7 +46,8 @@
     602e6, 608e6, 614e6, 620e6, 626e6, 632e6, 638e6, 644e6, 650e6, 656e6, 662e6, 668e6,
     674e6, 680e6, 686e6, 692e6, 698e6, 704e6, 710e6, 716e6, 722e6, 728e6, 734e6, 740e6,
     746e6, 752e6, 758e6, 764e6, 770e6, 776e6, 782e6, 788e6, 794e6, 800e6, 806e6, 812e6,
-    818e6, 824e6, 830e6, 836e6, 842e6, 848e6, 854e6, 860e6, 866e6, 872e6, 878e6, 884e6};
+    818e6, 824e6, 830e6, 836e6, 842e6, 848e6, 854e6, 860e6, 866e6, 872e6, 878e6, 884e6,
+};
 /// NORTH AMERICA end frequencies
 const double northAmericaEndFrequencies[84] = {
     0,     0,     60e6,  66e6,  72e6,  82e6,  88e6,  180e6, 186e6, 192e6, 198e6, 204e6,
@@ -55,7 +56,8 @@
     608e6, 614e6, 620e6, 626e6, 632e6, 638e6, 644e6, 650e6, 656e6, 662e6, 668e6, 674e6,
     680e6, 686e6, 692e6, 698e6, 704e6, 710e6, 716e6, 722e6, 728e6, 734e6, 740e6, 746e6,
     752e6, 758e6, 764e6, 770e6, 776e6, 782e6, 788e6, 794e6, 800e6, 806e6, 812e6, 818e6,
-    824e6, 830e6, 836e6, 842e6, 848e6, 854e6, 860e6, 866e6, 872e6, 878e6, 884e6, 890e6};
+    824e6, 830e6, 836e6, 842e6, 848e6, 854e6, 860e6, 866e6, 872e6, 878e6, 884e6, 890e6,
+};
 
 /// EUROPE: 70 elements (index 0 - 69); valid channels = 5 - 12, 21 - 69
 const int europeArrayLength = 70;
@@ -66,7 +68,8 @@
     494e6, 502e6, 510e6, 518e6, 526e6, 534e6, 542e6, 550e6, 558e6, 566e6, 574e6, 582e6,
     590e6, 598e6, 606e6, 614e6, 622e6, 630e6, 638e6, 646e6, 654e6, 662e6, 670e6, 678e6,
     686e6, 694e6, 702e6, 710e6, 718e6, 726e6, 734e6, 742e6, 750e6, 758e6, 766e6, 774e6,
-    782e6, 790e6, 798e6, 806e6, 814e6, 822e6, 830e6, 838e6, 846e6, 854e6};
+    782e6, 790e6, 798e6, 806e6, 814e6, 822e6, 830e6, 838e6, 846e6, 854e6,
+};
 /// EUROPE end frequencies
 const double europeEndFrequencies[70] = {
     0,     0,     0,     0,     0,     181e6, 188e6, 195e6, 202e6, 209e6, 216e6, 223e6,
@@ -74,7 +77,8 @@
     502e6, 510e6, 518e6, 526e6, 534e6, 542e6, 550e6, 558e6, 566e6, 574e6, 582e6, 590e6,
     598e6, 606e6, 614e6, 622e6, 630e6, 638e6, 646e6, 654e6, 662e6, 670e6, 678e6, 686e6,
     694e6, 702e6, 710e6, 718e6, 726e6, 734e6, 742e6, 750e6, 758e6, 766e6, 774e6, 782e6,
-    790e6, 798e6, 806e6, 814e6, 822e6, 830e6, 838e6, 846e6, 854e6, 862e6};
+    790e6, 798e6, 806e6, 814e6, 822e6, 830e6, 838e6, 846e6, 854e6, 862e6,
+};
 
 /// JAPAN: 63 elements (index 0 - 62); valid channels = 1 - 62
 const int japanArrayLength = 63;
@@ -84,14 +88,16 @@
     470e6, 476e6, 482e6, 488e6, 494e6, 500e6, 506e6, 512e6, 518e6, 524e6, 530e6, 536e6, 542e6,
     548e6, 554e6, 560e6, 566e6, 572e6, 578e6, 584e6, 590e6, 596e6, 602e6, 608e6, 614e6, 620e6,
     626e6, 632e6, 638e6, 644e6, 650e6, 656e6, 662e6, 668e6, 674e6, 680e6, 686e6, 692e6, 698e6,
-    704e6, 710e6, 716e6, 722e6, 728e6, 734e6, 740e6, 746e6, 752e6, 758e6, 764e6};
+    704e6, 710e6, 716e6, 722e6, 728e6, 734e6, 740e6, 746e6, 752e6, 758e6, 764e6,
+};
 /// JAPAN end frequencies
 const double japanEndFrequencies[63] = {
     0,     96e6,  102e6, 108e6, 176e6, 182e6, 188e6, 194e6, 198e6, 204e6, 210e6, 216e6, 222e6,
     476e6, 482e6, 488e6, 494e6, 500e6, 506e6, 512e6, 518e6, 524e6, 530e6, 536e6, 542e6, 548e6,
     554e6, 560e6, 566e6, 572e6, 578e6, 584e6, 590e6, 596e6, 602e6, 608e6, 614e6, 620e6, 626e6,
     632e6, 638e6, 644e6, 650e6, 656e6, 662e6, 668e6, 674e6, 680e6, 686e6, 692e6, 698e6, 704e6,
-    710e6, 716e6, 722e6, 728e6, 734e6, 740e6, 746e6, 752e6, 758e6, 764e6, 770e6};
+    710e6, 716e6, 722e6, 728e6, 734e6, 740e6, 746e6, 752e6, 758e6, 764e6, 770e6,
+};
 
 TvSpectrumTransmitterHelper::TvSpectrumTransmitterHelper()
     : m_channel(nullptr),
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/spectrum/model/half-duplex-ideal-phy.h ns-3.38/src/spectrum/model/half-duplex-ideal-phy.h
--- ns-3.37/src/spectrum/model/half-duplex-ideal-phy.h	2022-11-01 17:37:24.711395700 -0700
+++ ns-3.38/src/spectrum/model/half-duplex-ideal-phy.h	2023-03-16 20:54:23.824869200 -0700
@@ -210,7 +210,7 @@
 
     Ptr<MobilityModel> m_mobility;  //!< Mobility model
     Ptr<AntennaModel> m_antenna;    //!< Antenna model
-    Ptr<NetDevice> m_netDevice;     //!< NetDevice connected to theis phy
+    Ptr<NetDevice> m_netDevice;     //!< NetDevice connected to this phy
     Ptr<SpectrumChannel> m_channel; //!< Channel
 
     Ptr<SpectrumValue> m_txPsd;       //!< Tx power spectral density
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/spectrum/model/matrix-based-channel-model.h ns-3.38/src/spectrum/model/matrix-based-channel-model.h
--- ns-3.37/src/spectrum/model/matrix-based-channel-model.h	2022-11-01 17:37:24.711395700 -0700
+++ ns-3.38/src/spectrum/model/matrix-based-channel-model.h	2023-03-16 20:54:23.824869200 -0700
@@ -22,6 +22,7 @@
 #define MATRIX_BASED_CHANNEL_H
 
 // #include <complex>
+#include <ns3/matrix-array.h>
 #include <ns3/nstime.h>
 #include <ns3/object.h>
 #include <ns3/phased-array-model.h>
@@ -49,31 +50,47 @@
      */
     ~MatrixBasedChannelModel() override;
 
-    typedef std::vector<double> DoubleVector;         //!< type definition for vectors of doubles
-    typedef std::vector<DoubleVector> Double2DVector; //!< type definition for matrices of doubles
-    typedef std::vector<Double2DVector>
-        Double3DVector; //!< type definition for 3D matrices of doubles
-    typedef std::vector<PhasedArrayModel::ComplexVector>
-        Complex2DVector; //!< type definition for complex matrices
-    typedef std::vector<Complex2DVector>
-        Complex3DVector; //!< type definition for complex 3D matrices
+    /// Type definition for vectors of doubles
+    using DoubleVector = std::vector<double>;
+
+    /// Type definition for matrices of doubles
+    using Double2DVector = std::vector<DoubleVector>;
+
+    /// Type definition for 3D matrices of doubles
+    using Double3DVector = std::vector<Double2DVector>;
+
+    using Complex2DVector = ComplexMatrixArray; //!< Create an alias for 2D complex vectors
+    using Complex3DVector = ComplexMatrixArray; //!< Create an alias for 3D complex vectors
 
     /**
      * Data structure that stores a channel realization
      */
     struct ChannelMatrix : public SimpleRefCount<ChannelMatrix>
     {
-        Complex3DVector m_channel; //!< channel matrix H[u][s][n].
-        Time m_generatedTime;      //!< generation time
-        std::pair<uint32_t, uint32_t>
-            m_antennaPair; //!< the first element is the ID of the antenna of the s-node (the
-                           //!< antenna of the transmitter when the channel was generated), the
-                           //!< second element is ID of the antenna of the u-node antenna (the
-                           //!< antenna of the receiver when the channel was generated)
-        std::pair<uint32_t, uint32_t>
-            m_nodeIds; //!< the first element is the s-node ID (the transmitter when the channel was
-                       //!< generated), the second element is the u-node ID (the receiver when the
-                       //!< channel was generated)
+        /**
+         * Channel matrix H[u][s][n].
+         */
+        Complex3DVector m_channel;
+
+        /**
+         * Generation time.
+         */
+        Time m_generatedTime;
+
+        /**
+         * The first element is the ID of the antenna of the s-node (the
+         * antenna of the transmitter when the channel was generated), the
+         * second element is ID of the antenna of the u-node antenna (the
+         * antenna of the receiver when the channel was generated).
+         */
+        std::pair<uint32_t, uint32_t> m_antennaPair;
+
+        /**
+         * The first element is the s-node ID (the transmitter when the channel was
+         * generated), the second element is the u-node ID (the receiver when the
+         * channel was generated).
+         */
+        std::pair<uint32_t, uint32_t> m_nodeIds;
 
         /**
          * Destructor for ChannelMatrix
@@ -105,18 +122,41 @@
      */
     struct ChannelParams : public SimpleRefCount<ChannelParams>
     {
-        Time m_generatedTime;   //!< generation time
-        DoubleVector m_delay;   //!< cluster delay in nanoseconds.
-        Double2DVector m_angle; //!< cluster angle angle[direction][n], where direction = 0(AOA),
-                                //!< 1(ZOA), 2(AOD), 3(ZOD) in degree.
-        DoubleVector m_alpha;   //!< alpha term per cluster as described in 3GPP TR 37.885 v15.3.0,
-                                //!< Sec. 6.2.3 for calculating doppler
-        DoubleVector m_D; //!< D term per cluster as described in 3GPP TR 37.885 v15.3.0, Sec. 6.2.3
-                          //!< for calculating doppler
-        std::pair<uint32_t, uint32_t>
-            m_nodeIds; //!< the first element is the s-node ID (the transmitter when the channel
-                       //!< params were generated), the second element is the u-node ID (the
-                       //!< receiver when the channel params were generated generated)
+        /**
+         * Generation time.
+         */
+        Time m_generatedTime;
+
+        /**
+         * Cluster delay in nanoseconds.
+         */
+        DoubleVector m_delay;
+
+        /**
+         * Cluster angle angle[direction][n], where direction = 0(AOA), 1(ZOA), 2(AOD), 3(ZOD)
+         * in degree.
+         */
+        Double2DVector m_angle;
+
+        /**
+         * Alpha term per cluster as described in 3GPP TR 37.885 v15.3.0, Sec. 6.2.3
+         * for calculating doppler.
+         */
+        DoubleVector m_alpha;
+
+        /**
+         * D term per cluster as described in 3GPP TR 37.885 v15.3.0, Sec. 6.2.3
+         * for calculating doppler.
+         */
+        DoubleVector m_D;
+
+        /**
+         * The first element is the s-node ID (the transmitter when the channel params were
+         * generated), the second element is the u-node ID (the receiver when the channel params
+         * were generated generated).
+         */
+        std::pair<uint32_t, uint32_t> m_nodeIds;
+
         /**
          * Destructor for ChannelParams
          */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/spectrum/model/multi-model-spectrum-channel.cc ns-3.38/src/spectrum/model/multi-model-spectrum-channel.cc
--- ns-3.37/src/spectrum/model/multi-model-spectrum-channel.cc	2022-11-01 17:37:24.711395700 -0700
+++ ns-3.38/src/spectrum/model/multi-model-spectrum-channel.cc	2023-03-16 20:54:23.824869200 -0700
@@ -148,20 +148,16 @@
 
     ++m_numDevices;
 
-    RxSpectrumModelInfoMap_t::iterator rxInfoIterator =
-        m_rxSpectrumModelInfoMap.find(rxSpectrumModelUid);
+    auto [rxInfoIterator, inserted] =
+        m_rxSpectrumModelInfoMap.emplace(rxSpectrumModelUid, RxSpectrumModelInfo(rxSpectrumModel));
 
-    if (rxInfoIterator == m_rxSpectrumModelInfoMap.end())
-    {
-        // spectrum model unknown, add it to the list of RxSpectrumModels
-        std::pair<RxSpectrumModelInfoMap_t::iterator, bool> ret;
-        ret = m_rxSpectrumModelInfoMap.insert(
-            std::make_pair(rxSpectrumModelUid, RxSpectrumModelInfo(rxSpectrumModel)));
-        NS_ASSERT(ret.second);
-        // also add the phy to the newly created set of SpectrumPhy for this RxSpectrumModel
-        ret.first->second.m_rxPhys.push_back(phy);
+    // rxInfoIterator points either to the newly inserted element or to the element that
+    // prevented insertion. In both cases, add the phy to the element pointed to by rxInfoIterator
+    rxInfoIterator->second.m_rxPhys.push_back(phy);
 
-        // and create the necessary converters for all the TX spectrum models that we know of
+    if (inserted)
+    {
+        // create the necessary converters for all the TX spectrum models that we know of
         for (TxSpectrumModelInfoMap_t::iterator txInfoIterator = m_txSpectrumModelInfoMap.begin();
              txInfoIterator != m_txSpectrumModelInfoMap.end();
              ++txInfoIterator)
@@ -182,11 +178,6 @@
             }
         }
     }
-    else
-    {
-        // spectrum model is already known, just add the device to the corresponding list
-        rxInfoIterator->second.m_rxPhys.push_back(phy);
-    }
 }
 
 TxSpectrumModelInfoMap_t::const_iterator
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/spectrum/model/single-model-spectrum-channel.cc ns-3.38/src/spectrum/model/single-model-spectrum-channel.cc
--- ns-3.37/src/spectrum/model/single-model-spectrum-channel.cc	2022-11-01 17:37:24.711395700 -0700
+++ ns-3.38/src/spectrum/model/single-model-spectrum-channel.cc	2023-03-16 20:54:23.824869200 -0700
@@ -84,7 +84,10 @@
 SingleModelSpectrumChannel::AddRx(Ptr<SpectrumPhy> phy)
 {
     NS_LOG_FUNCTION(this << phy);
-    m_phyList.push_back(phy);
+    if (std::find(m_phyList.cbegin(), m_phyList.cend(), phy) == m_phyList.cend())
+    {
+        m_phyList.push_back(phy);
+    }
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/spectrum/model/spectrum-converter.h ns-3.38/src/spectrum/model/spectrum-converter.h
--- ns-3.37/src/spectrum/model/spectrum-converter.h	2022-11-01 17:37:24.711395700 -0700
+++ ns-3.38/src/spectrum/model/spectrum-converter.h	2023-03-16 20:54:23.824869200 -0700
@@ -44,7 +44,7 @@
     /**
      * Create a SpectrumConverter class that will be able to convert ValueVsFreq
      * instances defined over one SpectrumModel to corresponding ValueVsFreq
-     * instances defined over a diffent SpectrumModel
+     * instances defined over a different SpectrumModel
      *
      * @param fromSpectrumModel the SpectrumModel to convert from
      * @param toSpectrumModel the SpectrumModel to convert to
